/***************************************************************************
                          cpalette.h  -  description
                             -------------------
    begin                : Wed Apr 25 2001
    copyright            : (C) 2001 by Franz Schmid
    email                : Franz.Schmid@altmuehlnet.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CPALETTE_H
#define CPALETTE_H

#include <qdialog.h>
#include <qlistbox.h>
#include <qpixmap.h>
#include <qrect.h>
#include <qlabel.h>
#include <qpopupmenu.h>
#include <qfont.h>
#include "icontbutton.h"
#include "iconmenubutton.h"
#include "scribusdoc.h"

/**
  *@author Franz Schmid
  */

class Cpalette : public QDialog  {
Q_OBJECT
public: 
	Cpalette(QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0);
	~Cpalette();
  void paintEvent(QPaintEvent *);
  void closeEvent(QCloseEvent *ce);
	
	QListBox *ListBox1;
	IconTButton *Inhalt;
	IconTButton *Innen;
	IconMenuButton *PM1;
	QPopupMenu *ShaMenu;
	QLabel *Stext;
	int Mode;
	QString sFarbe;
	CListe Farbliste;
	
public slots:
	void InhaltButton();
	void InnenButton();
	void SetColors(CListe farben);
	void updateCList();
	void updateBoxS(QString Farbe);
	void selFarbe(QListBoxItem *c);
	void setActFarben(QString p, QString b, int shp, int shb);
	int SetMen(int c);
	void setActShade(int);
	
signals:
	void Schliessen();
	void NewPen(QString);
	void NewBrush(QString);
	void NewPenShade(int);
	void NewBrushShade(int);
	void QueryItem();
};

#endif
